<template>
    <div class="push-component-container">
        <div class="subscribes__table">
            <b-form-input
                v-model="searchQuery"
                class="my-input"
                type="text"
                name="search"
                placeholder="Search"
                @keyup="search(1)"
            />
            <div v-if="pushSubscribers.subscribers[0]">
                <div class="table-responsive">
                    <table class="table-hover">
                        <thead class="table-header">
                            <tr>
                                <th class="table-first-cell">
                                    Browser
                                </th>
                                <th>Platform</th>
                                <th>Last Active</th>
                                <th />
                            </tr>
                        </thead>
                        <tbody class="table-body">
                            <tr
                                v-for="(subscriber, index) in pushSubscribers.subscribers"
                                :key="index"
                                class="table-body-row"
                            >
                                <th class="table-first-cell">
                                    {{ subscriber.browser_name }}
                                </th>
                                <th>{{ subscriber.browser_platform }}</th>
                                <th>
                                    <span v-if="isSame(subscriber.updated_at)">
                                        Today
                                    </span>
                                    {{ subscriber.updated_at | moment('from') }}
                                </th>
                                <th>
                                    <b-btn
                                        class="btn red-button"
                                        @click="[deleteModal = true, subscriberId = subscriber.id]"
                                    >
                                        Delete
                                    </b-btn>
                                </th>
                            </tr>
                        </tbody>
                        <b-modal
                            v-model="deleteModal"
                            size="md"
                            hide-backdrop
                            content-class="shadow"
                            title="Are you sure you want to delete this subscriber?"
                            hide-footer
                        >
                            <b-btn
                                type="button"
                                class="btn red-button"
                                @click="deleteSubscribersPush(subscriberId)"
                            >
                                Yes
                            </b-btn>
                            <b-btn
                                type="button"
                                class="btn light-blue-btn"
                                @click="deleteModal = false"
                            >
                                No
                            </b-btn>
                        </b-modal>
                    </table>
                    <paginate
                        v-model="pageNumber.number"
                        :page-count="Math.ceil(pushSubscribers.total_subscribers / pushSubscribers.limit)"
                        :click-handler="pagePushHandler"
                        :prev-text="'Previous'"
                        :next-text="'Next'"
                        :container-class="'pagination'"
                    />
                </div>
            </div>
            <div v-else>
                Not Found
            </div>
        </div>
    </div>
</template>

<script>
import headers from "../../../helpers/authHeader";
import link from "../../../helpers/backLink";

export default {
    name: "PushTable",
    mixins: [headers, link],
    props: ['pushSubscribers', 'pageNumber'],
    data() {
        return {
            searchQuery: '',
            subscriberId: null,
            deleteModal: false,
            subscriberStatus: null,
        }
    },
    methods: {
        pagePushHandler(e) {
            return this.$emit('getPushSubscribers', e)
        },
        search(pageNum = 1) {
            this.pageNumber.number = pageNum;
            axios.get(this.getSegment() + '/home/push/subscribers/?search=' + this.searchQuery, this.getUserHeader()).then(response => {
                this.pushSubscribers.subscribers = response.data.subscribers;
            });
        },
        isSame(date) {
            return moment().isSame(date, 'day');
        },
        deleteSubscribersPush(id) {
            axios.delete(this.getSegment() + '/home/push/subscribers/' + id, this.getUserHeader()).then(response => {
                this.$emit('getPushSubscribers')
                this.deleteModal = false
                this.$notify({
                    type: 'success',
                    title: 'Deleted'
                });
            })
        }
    }

}
</script>

<style scoped lang="scss">

.pagination {
    padding: 0 !important;
}

.my-input {
    max-width: 280px;
    position: absolute;
    top: -70px;
}

.push-component-container {
    display: flex;
    justify-content: space-between;
    @media screen and (max-width: 1230px) {
        flex-direction: column-reverse;
    }
}
.subscribes__table {
    max-width: 650px !important;
}
.table-hover {
    -webkit-box-shadow: 0 5px 20px rgba(200, 208, 222, 0.2);
    box-shadow: 0 5px 20px rgba(200, 208, 222, 0.2);
    background: transparent;
    border-spacing: 0;
    border-collapse: collapse;


    th {
        padding: 18px 10px;
        margin-bottom: 5px;
        font-weight: 500;
    }

    thead {
        th {
            font-weight: bold;
        }
    }
}

tr {
    border-radius: 10px;
}

.table-hover {
    min-width: 900px;
}

.delete-button {
    background: #feedec;
    font-weight: bold;
    color: #ee514a;

    &:hover {
        background: #ed4740;
        color: #ffffff;
    }
}

.table-hover tr {
    border-bottom: 3px solid #F5F6FA;
    border-radius: 10px;
}

.table-first-cell {
    text-align: left;
}

.active-all {
    font-weight: 600;
    color: #4786FF;
}

.text-subscribers {
    color: #8492a6;
}

.filter-container {
    margin-top: 25px;
    min-width: 220px;
    display: flex;
    justify-content: space-between;
}

.table-header {
    padding: 10px;
}

.table-body {
    background: white;
    border-radius: 10px;

    &:hover {
        background: #fbfcfd;
    }
}

.table-hover tbody tr:hover {
    background-color: #fbfcfd;
}
</style>
